/**
 * Written by M. El Bastami			Aug 27, 2015
 * Purpose:	Modal Waiting Box that uses bootstrap
 *
 *
 * Change Log:
 * 12 Apr 2016	Dean Chan	Changed check for modal dialog existing to be greater than 0 instead of just 1.  Added more checks for mobile
 */

window.onload = function() { if ($("#modalWaitingBox").length > 0) {$("#modalWaitingBox").modal('hide');} };
window.onunload = function(){};
window.onpageshow = function(evt) {
	if ($("#modalWaitingBox").length > 0) {$("#modalWaitingBox").modal('hide');}
};

$(document).ready(function(){
	if ($("#modalWaitingBox").length == 0){
		$('body').append( "<div class=\"modal fade\" id=\"modalWaitingBox\" role=\"dialog\"> </div>");
		modalDialog = $("<div class=\"modal-dialog modal-sm\"> </div>");
		modalContent = $("<div class=\"modal-content\"> </div>");
		modalHeader = $("<div id=\"modalCloseButton\" class=\"modal-header\" id =\"modalHeader\"> </div>");
		modalButton = $("<button type=\"button\" class=\"close\" data-dismiss=\"modal\">&times;</button>");
		modalTitle = $("<h4 class=\"modal-title\" id =\"modalTitle\">Working</h4>");
		modalBody = $("<div class=\"modal-body\" id = \"modalBody\"> </div>");
		modalSpinner = $("<div id=\"spinningWheel\" class=\"sk-spinner sk-spinner-fading-circle\"> </div>");
		modalCircle1 = $("<div class=\"sk-circle1 sk-circle\"></div>");
		modalCircle2 = $("<div class=\"sk-circle2 sk-circle\"></div>");
		modalCircle3 = $("<div class=\"sk-circle3 sk-circle\"></div>");
		modalCircle4 = $("<div class=\"sk-circle4 sk-circle\"></div>");
		modalCircle5 = $("<div class=\"sk-circle5 sk-circle\"></div>");
		modalCircle6 = $("<div class=\"sk-circle6 sk-circle\"></div>");
		modalCircle7 = $("<div class=\"sk-circle7 sk-circle\"></div>");
		modalCircle8 = $("<div class=\"sk-circle8 sk-circle\"></div>");
		modalCircle9 = $("<div class=\"sk-circle9 sk-circle\"></div>");
		modalCircle10 = $("<div class=\"sk-circle10 sk-circle\"></div>");
		modalCircle11 = $("<div class=\"sk-circle11 sk-circle\"></div>");
		modalCircle12 = $("<div class=\"sk-circle12 sk-circle\"></div>");

		//Add elements now
		modalSpinner.append(modalCircle1);
		modalSpinner.append(modalCircle2);
		modalSpinner.append(modalCircle3);
		modalSpinner.append(modalCircle4);
		modalSpinner.append(modalCircle5);
		modalSpinner.append(modalCircle6);
		modalSpinner.append(modalCircle7);
		modalSpinner.append(modalCircle8);
		modalSpinner.append(modalCircle9);
		modalSpinner.append(modalCircle10);
		modalSpinner.append(modalCircle11);
		modalSpinner.append(modalCircle12);

		modalBody.append(modalTitle);
		modalBody.append(modalSpinner);

		modalHeader.append(modalButton);

		modalContent.append(modalHeader);
		modalContent.append(modalBody);

		modalDialog.append(modalContent);

		$("#modalWaitingBox").append(modalDialog);
	}
});



function showModalDialog(title, message) {
	$("#modalHeader").html(title);
	$("#modalTitle").html(message);
	$("#modalWaitingBox").modal('show');
}


function closeModalWaiting(){
	if ( ($("#modalWaitingBox").data('bs.modal') || {isShown: false}).isShown ){
		$("#modalWaitingBox").modal('hide');
	}
}

function updateWaitingResult(message, displayWheel){
	$("#modalTitle").html(message);

	if(displayWheel=="show"){
		//Something is still waiting
		$("#spinningWheel").show();
	} else {
		//No more waiting, so clear the timer
		////clearTimeout(waitingTimer);
		$("#spinningWheel").hide();
	}
$("#modalWaitingBox").modal('show');//re-open the dialog if the user closes it before operation is finished

}

function displayCloseButton(){
    //var closeButton = $("<button type=\"button\" class=\"close\" data-dismiss=\"modal\">&times;</button>");
    //$("#modalCloseButton").append(closeButton);
    //$("#modalWaitingBox").modal('show');
}

/*
 * function to handle invoking the working Dialog
 * @payload - form with variables to submit
 * @destination - destination of the form to submit to (Controller)
 * @destinationtype - Is this a popup or will this stay in the same window to submit
 * @popupHeight [popup only] - The height of the popup window to show
 * @popupWidth [popup only] - The width of the popup window to show
 * @windowName [popup only] - The name of the popup window so that we could have multiple windows for power users in the future
 * @title [non popups] - This is the title of the dialog that shows when moving to another page
 * @message [non popups] - This is the message to display above the spinning wheel before moving to another page
 */
function invokeAction(payload, destination, destinationType, popupWidth, popupHeight, windowName, title, message){

	var toType = function(obj) {
		 return ({}).toString.call(obj).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
	}

	//Since Javascript doesn't have default values this check sets default values if they are not present
	payload = typeof payload != 'undefined' ? payload : '';
	destination = typeof destination != 'undefined' ? destination : '';
	destinationType = typeof destinationType != 'undefined' ? destinationType : 'nopopup';
	popupHeight = typeof popupHeight != 'undefined' ? popupHeight : 1024;
	popupWidth = typeof popupWidth != 'undefined' ? popupWidth : 768;
	windowName = typeof windowName != 'undefined' ? windowName : 'popupWin';
	title = typeof title != 'undefined' ? title : 'Loading';
	message = typeof message != 'undefined' ? message : '';

	if(title.length > 71){
		title = title.substring(0, 68) + "...";
	}
	if (destinationType == "nopopup"){
		showModalDialog(title,message);
		setTimeout(function(){
			if (destination != ""){
				if (toType(payload) == 'object') {
					$(payload).attr('action', destination);
				} else {
					$('form[name="'+payload+'"]').attr('action', destination);
				}
			}
			if (toType(payload) == 'object') {
				$(payload).attr("target",'_self');
				$(payload).submit();
			} else {
				$('form[name="'+payload+'"]').attr('target', '_self');
				$('form[name="'+payload+'"]').submit();
			}
		},
		450);
	} else { //handles popup and others
		//check if a window with the same destinationType exists
		if (destinationType != null){
			destinationType = destinationType + "1";
		} 
		popup = window.open('/index.php/Working', destinationType,'scrollbars=yes,resizable=yes,width='+popupWidth+',height='+popupHeight);
		popup.focus();
		//e.preventDefault();
		setTimeout(function(){
			
			if (destination != ""){
				if (toType(payload) == 'object') {
					$(payload).attr('action', destination);
				} else {
					$('form[name="'+payload+'"]').attr('action', destination);
				}
			} 
			if (toType(payload) == 'object') {
				$(payload).attr("target",destinationType);
				$(payload).submit();
			} else {
				$('form[name="'+payload+'"]').attr('target', destinationType);
				$('form[name="'+payload+'"]').submit();
			}
		},
		450);
		return popup;
	}
}

$(window).bind('unload', function(){
	//closeModalWaiting();

});
